SystemOrganization addCategory: #'SqueakSource-Storage-Core'!

WAObject subclass: #SSStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSource-Storage-Core'!

!SSStorage commentStamp: 'al 1/17/2006 16:31' prior: 0!
AUTOMATIC IMAGE SAVING (as alternative to ref streams)
storage := [ 
	[ Smalltalk garbageCollect.
	  Smalltalk saveSession.
	  (Delay forSeconds: 60 * 60) wait ] repeat ] forkAt: 51.
storage terminate.

====================================

MIGRATION SCRIPTS (old squeaksource instance on kilana to macamis)

"Chronology library changes"
(TimeStamp allInstances
	select: [:each | (each instVarNamed: 'seconds')
			isKindOf: Date])
	do: [:each | each become: (
		TimeStamp
			date: (Date julianDayNumber: (each instVarNamed: 'seconds') start)
			time: ((each instVarNamed: 'offset') instVarNamed: 'nanos' put: 0;
					 yourself))] displayingProgress: 'Converting TimeStamp'

"New instvars in MCVersionInfo. Note, this would normally be doable with SmartRefStream, but it seams to be broken for larger data sets."			
(MCVersionInfo allInstances
	select: [:each | (each stepChildren isKindOf: UUID) and: [ each author isNil ]])
	do: [:each | 
		8 to: 3 by: -1 do: [ :i |
			each instVarAt: i put: (each instVarAt: i - 1) ] ] displayingProgress: 'Converting MCVersionInfo'!

!SSStorage class methodsFor: 'defaults' stamp: 'dkh 05/23/2011 16:32'!
defaultSubclass
	
	" let the platform decide: sortet list of associations: priority -> storage. So, we pick the last, resp. its Value"
	^ (self allSubclasses collect: [:storageClass |
		(GRPlatform current squeakSourcePriorityForStorage: storageClass name asString) -> storageClass])
		asSortedCollection last value.! !

!SSStorage methodsFor: 'logging' stamp: 'jgf 7/24/2009 09:52'!
getLogOfSize: anInteger 
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'DaleHenrichs 07/01/2010 13:49'!
loadDiffNamed: diffName from: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
loadMonticello: aVersion from: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 2/1/2004 13:37'!
loadRepository
	self subclassResponsibility! !

!SSStorage methodsFor: 'logging' stamp: 'jgf 7/24/2009 10:05'!
log: aString
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'DaleHenrichs 07/01/2010 13:49'!
saveDiff: data named: diffName to: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'bf 5/26/2005 12:00'!
saveDiff: aString of: aVersion to: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'jgf 7/24/2009 08:10'!
saveMonticello: aString of: aVersion to: aProject
	self subclassResponsibility! !

!SSStorage methodsFor: 'actions' stamp: 'lr 1/31/2004 21:16'!
saveRepository: aRepository
	self subclassResponsibility! !

!SSStorage methodsFor: 'system startup' stamp: 'topa 10/25/2010 12:14'!
shutDownStorage
	"Allow concrete subclasses of ourselves to react to System shut down.
	This, however, should only be called on the =current= storage"
	"defaults to a no-op"! !

!SSStorage methodsFor: 'system startup' stamp: 'topa 10/4/2010 09:27'!
startUpStorage
	"Allow concrete subclasses of ourselves to react to System start up.
	This, however, should only be called on the =current= storage"
	"defaults to a no-op"! !

!GRPlatform methodsFor: '*SqueakSource-Storage-Core' stamp: 'topa 5/24/2011 15:09'!
reducedConflictQueue

	self subclassResponsibility! !

!GRPlatform methodsFor: '*SqueakSource-Storage-Core' stamp: 'topa 10/4/2010 11:28'!
squeakSourcePriorityForStorage: aStorageClassName

	self subclassResponsibility! !
